#extension GL_ARB_texture_rectangle : enable

uniform sampler2DRect brain;

const int OFF=0;
const int ON=1;
const int DEAD=2;

void main()
{
  ivec2 pos=ivec2(gl_FragCoord);

  float state=texelFetch(brain,pos).r;
  int newState;
  int numNeighbours=0;

  switch(state) {
  case OFF:
    if(texelFetch(brain,ivec2(pos.x-1,pos.y-1)).r==ON) {
      numNeighbours++;
    }
    if(texelFetch(brain,ivec2(pos.x-1,pos.y)).r==ON) {
      numNeighbours++;
    }
    if(texelFetch(brain,ivec2(pos.x-1,pos.y+1)).r==ON) {
      numNeighbours++;
    }
    if(texelFetch(brain,ivec2(pos.x,pos.y-1)).r==ON) {
      numNeighbours++;
    }
    if(texelFetch(brain,ivec2(pos.x,pos.y+1)).r==ON) {
      numNeighbours++;
    }
    if(texelFetch(brain,ivec2(pos.x+1,pos.y-1)).r==ON) {
      numNeighbours++;
    }
    if(texelFetch(brain,ivec2(pos.x+1,pos.y)).r==ON) {
      numNeighbours++;
    }
    if(texelFetch(brain,ivec2(pos.x+1,pos.y+1)).r==ON) {
      numNeighbours++;
    }
    if(numNeighbours==2) {
      newState=ON;
    } else {
      newState=OFF;
    }
    break;
  case ON:
    newState=DEAD;
    break;
  case DEAD:
    newState=OFF;
    break;
  }

  gl_FragColor=vec4(newState,0,0,0);
}
