#ifndef FPSCAMERA_H
#define FPSCAMERA_H

#include "GL3Support/camera.h"

namespace GL3Support {
	class FPSCamera : public Camera {
	public:
		enum UpAxis {
			YAxis,
			ZAxis
		};

		FPSCamera();
		~FPSCamera();

		void setUpAxis(UpAxis upAxis) { this->upAxis=upAxis; updateTransformation(); };
		UpAxis getUpAxis() { return upAxis; };

		void moveForward(double amount);
		void moveBackward(double amount);
		void moveLeft(double amount);
		void moveRight(double amount);
		void moveUp(double amount);
		void moveDown(double amount);

		void move(glm::vec3 direction);

		void rotateLeftRight(float amount);
		void rotateUpDown(float amount);

		void setPosition(glm::vec3 position);
		glm::vec3 getPosition() { return position; };
		// override setPositionLookAt from Camera to write to own position vector as well
		void setPositionLookAt(glm::vec3 position, glm::vec3 front, glm::vec3 up);

		void setYaw(float yaw) { this->yaw=yaw; updateTransformation(); };
		float getYaw() { return yaw; };
		void setPitch(float pitch) { this->pitch=pitch; updateTransformation(); };
		float getPitch() { return pitch; };
		void setRoll(float roll) { this->roll=roll; updateTransformation(); };
		float getRoll() { return roll; };

	private:
		UpAxis upAxis;
		glm::vec3 position;
		float yaw, pitch, roll;
	
		void updateTransformation();
	};
}

#endif
