#ifndef FRAMEBUFFERMANAGER_H_
#define FRAMEBUFFERMANAGER_H_

#include <map>
#include <string>

#include "GLTB/refptr.h"

#include "GL3Support/framebuffer.h"

namespace GL3Support {
	class FramebufferManager {
	private:
		FramebufferManager();
		~FramebufferManager();

	public:
		gltb::RefPtr<Framebuffer> createFramebuffer(int width, int height, std::string name);

		gltb::RefPtr<Framebuffer> getFramebuffer(std::string name)
		{
			return framebuffers.find(name)->second;
		}

		void removeFramebuffer(std::string name);

		void clear();

		static FramebufferManager *getInstance();

	private:
		std::map<std::string, gltb::RefPtr<Framebuffer> > framebuffers;

		static FramebufferManager *instance;
	};
}

#endif /*FRAMEBUFFERMANAGER_H_*/
