#ifndef QUERY_H
#define QUERY_H

#include "GL/glew.h"

namespace GL3Support {
	class Query {
	public:
		enum QueryType {
			ElapsedTime=GL_TIME_ELAPSED_EXT,
			GeneratedPrimitives=GL_PRIMITIVES_GENERATED,
			SamplesPassed=GL_SAMPLES_PASSED
		};

		Query(QueryType type);
		~Query();

		// note that only one query of each type can be active at each time
		void start();
		void stop();
		bool isResultAvailable();
		unsigned long long getResult(bool block=true);

	private:
		QueryType type;
		unsigned int query;
	};
}

#endif
