#ifndef RESOURCEMANAGER_H
#define RESOURCEMANAGER_H

#include <vector>

#include "GLTB/refptr.h"
#include "GLTB/weakptr.h"

#include "GL3Support/resource.h"
#include "GL3Support/shader.h"
#include "GL3Support/texture.h"
#include "GL3Support/vertexbuffer.h"

namespace GL3Support {
	class ResourceManager {
	public:
		gltb::RefPtr<Shader> createShader();
		gltb::RefPtr<Texture> createTexture(Texture::Type type, Texture::Format format, int width, int height, std::string name, void *data=0);
#ifdef USE_DEVIL
		gltb::RefPtr<Texture> loadTexture(std::string filename);
#endif
		gltb::RefPtr<VertexBuffer> createVertexBuffer(void *sourceBuffer, int size, std::vector<VertexBuffer::ElementDescription> format);

		gltb::RefPtr<Texture> getTexture(std::string textureName);

		void reloadAll();

		std::vector<gltb::WeakPtr<Resource> > &getResources() { return resources; };

		static ResourceManager *getInstance();

	private:
		std::vector<gltb::WeakPtr<Resource> > resources;

		static ResourceManager *instance;
	};
}

#endif
