/*
 * state.h
 *
 *  Created on: Jul 24, 2010
 *      Author: gregor
 */

#ifndef STATE_H_
#define STATE_H_

#include "GL/glew.h"

#include "GLTB/referencedobject.h"
#include "GLTB/refptr.h"

#include "GL3Support/glenums.h"
#include "GL3Support/shader.h"

namespace GL3Support {
	class State : public gltb::ReferencedObject {
	public:
		State();

		// state variables
		bool depthTestEnabled;
		DepthTest depthTest;

		bool blendingEnabled;
		BlendFunction sourceBlendFunction;
		BlendFunction destinationBlendFunction;

		bool faceCullingEnabled;
		FaceCulling faceCulling;

		bool texture2DEnabled;
		bool texture2DRectEnabled;
		bool texture3DEnabled;
		bool textureCubeEnabled;

		gltb::RefPtr<Shader> shader;
	};
}

#endif /* STATE_H_ */
