/*
 * statemanager.h
 *
 *  Created on: Jul 24, 2010
 *      Author: gregor
 */

#ifndef STATEMANAGER_H_
#define STATEMANAGER_H_

#include "GLTB/refptr.h"

#include "GL3Support/state.h"

namespace GL3Support {
	class StateManager {
	public:

		gltb::RefPtr<State> getCurrentState() { return currentState; };

		void setState(gltb::RefPtr<State> state);
		void resetCurrentState();

		static StateManager *getInstance();

	private:
		StateManager();

		gltb::RefPtr<State> currentState;

		void updateDepthTest(gltb::RefPtr<State> state);
		void updateBlending(gltb::RefPtr<State> state);
		void updateFaceCulling(gltb::RefPtr<State> state);
		void updateTexturing(gltb::RefPtr<State> state);
		void updateShader(gltb::RefPtr<State> state);

		static StateManager *instance;
	};
}

#endif /* STATEMANAGER_H_ */
