#ifndef TRANSFORMABLE_H_
#define TRANSFORMABLE_H_

#include <glm/glm.hpp>
#include <glm/ext.hpp>

#include "GLTB/referencedobject.h"

namespace GL3Support {
	class Transformable : public gltb::ReferencedObject {
		public:
			virtual ~Transformable() {};

			virtual void setTransformationMatrix(glm::mat4 matrix) = 0;
			virtual glm::mat4 getTransformationMatrix() = 0;
			virtual void clearTransformationMatrix();
			virtual void translate(glm::vec3 displacement);
			virtual void rotate(glm::vec3 pivot, glm::quat rotation);
			virtual void scale(glm::vec3 pivot, glm::vec3 scale);
	};
}

#endif /*TRANSFORMABLE_H_*/
