#include "GL3Support/framebuffermanager.h"

namespace GL3Support {
	FramebufferManager *FramebufferManager::instance=0;

	FramebufferManager *FramebufferManager::getInstance()
	{
		if(instance==0) {
			instance=new FramebufferManager();
		}
		return instance;
	}

	FramebufferManager::FramebufferManager()
	{

	}

	FramebufferManager::~FramebufferManager()
	{

	}

	gltb::RefPtr<Framebuffer> FramebufferManager::createFramebuffer(int width, int height, std::string name)
	{
		GLuint handle;

		glGenFramebuffersEXT(1,&handle);
		gltb::RefPtr<Framebuffer> framebuffer=new Framebuffer(handle,width,height,name);
		framebuffers[name]=framebuffer;
		return framebuffer;
	}

	void FramebufferManager::removeFramebuffer(std::string name)
	{
		std::map<std::string, gltb::RefPtr<Framebuffer> >::iterator iter;

		iter=framebuffers.find(name);
		if(iter!=framebuffers.end()) {
			framebuffers.erase(iter);
		}
	}

	void FramebufferManager::clear()
	{
		framebuffers.clear();
	}
}
