#include "GL/glew.h"

#include "GL3Support/query.h"

namespace GL3Support {
	Query::Query(QueryType type)
	{
		this->type=type;
		glGenQueries(1,&query);
	}

	Query::~Query()
	{
		glDeleteQueries(1,&query);
	}

	void Query::start()
	{
		glBeginQuery(type,query);
	}

	void Query::stop()
	{
		glEndQuery(type);
	}

	bool Query::isResultAvailable() {
		int available=GL_FALSE;
		glGetQueryObjectiv(query, GL_QUERY_RESULT_AVAILABLE, &available);
		return (available==GL_TRUE ? true : false);
	}

	unsigned long long Query::getResult(bool block)
	{
		GLuint64EXT result;

		if(block) {
			while (!isResultAvailable());
		}
		glGetQueryObjectui64vEXT(query, GL_QUERY_RESULT, &result);
		return result;
	}
}
