#include "GL3Support/transformable.h"

namespace GL3Support {
	void Transformable::clearTransformationMatrix() {
		glm::mat4 identity(1.0);
		setTransformationMatrix(identity);
	}

	void Transformable::translate(glm::vec3 displacement) {
		glm::mat4 transformation=getTransformationMatrix();
		glm::mat4 displacementMatrix;
		glm::translate(displacementMatrix,displacement);
		transformation=displacementMatrix*transformation;
		setTransformationMatrix(transformation);
	}

	void Transformable::rotate(glm::vec3 pivot, glm::quat rotation) {
		translate(-1.0f*pivot);
		glm::mat4 transformation=getTransformationMatrix();
		glm::mat4 rotationMatrix=glm::mat4_cast(rotation);
		transformation=rotationMatrix*transformation;
		setTransformationMatrix(transformation);
		translate(pivot);
	}

	void Transformable::scale(glm::vec3 pivot, glm::vec3 scale) {
		translate(-1.0f*pivot);
		glm::mat4 transformation=getTransformationMatrix();
		glm::mat4 scaleMatrix;
		glm::scale(scaleMatrix,scale);
		transformation=scaleMatrix*transformation;
		setTransformationMatrix(transformation);
		translate(pivot);
	}
}
